#!/usr/bin/perl

$base_x = calc_off("0.1mm");
$base_y = calc_off("0.1mm");

$geom_x = 0;
$geom_y = 0;
$geom_xsize = 0;
$geom_ysize = 0;

$xoff = 0;
$yoff = 0;
$last_doff = 9;
$do_flip = 0;

#$dpi = 127;
#$dpi = 360;
$dpi = 600;

@color_char = ( " ", ".", "X", "#", "+", "Z", "e");
$xsize_pix = 375;
$ysize_pix = 470;

@color_set_white = ("#888888", "#CCCCCC");
@color_set_blu = ("#0C1F89", "#1423DC");
@color_set_red = ("#891F0C", "#B40C00");
@color_set_grn = ("#2B4F26", "#0FB047");
$color_silver = "#C0C0C0";
$color_gold   = "#AC9528";

$color_set[0] = $color_set_blu[0];
$color_set[2] = $color_set_blu[1];
$color_set[1] = "#4A4135"; # stop mask
$color_set[3] = "#FFFFFF"; # silk
$color_set[4] = $color_gold;
$color_set[5] = "#000000"; # drill
$color_set[6] = "#FF007F"; # error

$current_layer = 1;

$head = "";
$aperture_tab = "";
$aperture = "";

$color_opt = "green-silver";
$draw_start = 0;
$next = 0;
while ($#ARGV >= 0) {
	$arg = @ARGV[0];
	shift @ARGV;
	if ($arg =~ m/^-x/) {
		$next = 1;	
	} elsif ($arg =~ m/^-y/) {
		$next = 2;	
	} elsif ($arg =~ m/^-c/) {
		$next = 3;	
	} elsif ($arg =~ m/^-d/) {
		$next = 4;	
	} elsif ($arg =~ m/^-f/) {
		$do_flip = 1;
	} elsif ($arg =~ m/^-g/) {
		$next = 10;	
	} else {
		if ($next == 1) {
			$xoff = calc_off($arg);
			$next = 0;
#printf("xoff = %d\n",$xoff);
		} elsif ($next == 2) {
			$yoff = calc_off($arg);
			$next = 0;
#printf("yoff = %d\n",$yoff);
		} elsif ($next == 3) {
			$color_opt = $arg;
			$next = 0;
		} elsif ($next == 4) {
			$dpi = $arg;
			$next = 0;
		} elsif ($next == 10) {
			$geom_x = calc_off($arg);
			$next = 11;	
		} elsif ($next == 11) {
			$geom_y = calc_off($arg);
			$next = 12;	
		} elsif ($next == 12) {
			$geom_xsize = calc_off($arg);
			$next = 13;
		} elsif ($next == 13) {
			$geom_ysize = calc_off($arg);
			$next = 0;
		} else {
#printf("start func $s %d %d",$arg,$xoff,$yoff);
			if ($draw_start == 0) {
				draw_init( $base_x * 2 + $geom_xsize,  $base_y * 2 + $geom_ysize, $color_opt);
				$draw_start = 1;
			}
			do gerbconv($arg);
			$next = 0;
		}
	}
}

if ($draw_start > 0) {
	draw_out($do_flip);
}

sub calc_off {
    my($in,$off);
    $in = @_[0];
    $in =~ m/^(-*[0-9]+|-*[0-9]*\.[0-9]*)(|mm|in)$/;
    $off = $1;
    if ($2 =~ /^mm/) {
	    $off = $off * 10000 / 25.4;
    } elsif ($2 =~ /^in/) {
	    $off = $off * 10000;
    } else { # default inch
	    $off = $off * 10000;
    }
    return $off;
}

sub gerbconv {
    my($fn,$doff,$doff_cur);
    $doff = -1;
    $doff_cur = 0;
    $fn = @_[0];
    $head = "";

#printf("fn = %s\n",$fn);
    open(FILE,"$fn") || die;

    $current_layer++;
    while (<FILE>) {
	chop;
	chop if (/\r$/);
	if (/^M02\*/) {
	} elsif (/^M30/) { # drd
	} elsif (/^%$/) { # drd
	} elsif (/^.ADD([0-9]+)([CR],.*)/) {
		$aperture_def[$1] = $2;
	} elsif (/^.ADD([0-9]+)(OC8,.*)/) {
		$aperture_def[$1] = $2;
	} elsif (/^T([0-9]+)C([0-9]*\.[0-9]*)$/) { # drd
		$drill_def[$1] = sprintf("C,%s\*\%",$2);
	} elsif (/^D([0-9]+)\*/) {
		set_aperture($aperture_def[$1]);
	} elsif (/^T([0-9]+)$/) { # drd
		set_aperture($drill_def[$1]);
	}elsif (/^X([0-9]+)Y([0-9]+)D([0-9]+)\*/) {
		plot_aperture($1 - $geom_x + $base_x ,$2 - $geom_y + $base_y ,$3);
	}elsif (/^X([0-9]+)Y([0-9]+)$/) { # drd
		plot_aperture($1 - $geom_x + $base_x ,$2 - $geom_y + $base_y ,04);
	} else {
		$s = sprintf("%s\n",$_);
		$head = $head.$s;
	}
    }
    close(FILE);
}


sub conv_coord {
	my($x);
	$x = @_[0];
	return int(($x * $dpi + 5000.0)/ 10000.0);
}

sub draw_init {
	my($xsize,$ysize,$col_type);
	$xsize = @_[0];
	$ysize = @_[1];
	$col_type = @_[2];

	$xsize_pix = conv_coord($xsize);
	$ysize_pix = conv_coord($ysize);
	my($i,$j);
	if ($col_type =~ /red/) {
		$color_set[0] = $color_set_red[0];
		$color_set[2] = $color_set_red[1];
	} elsif ($col_type =~ /blu/) {
		$color_set[0] = $color_set_blu[0];
		$color_set[2] = $color_set_blu[1];
	} elsif ($col_type =~ /white/) {
		$color_set[0] = $color_set_white[0];
		$color_set[2] = $color_set_white[1];
		$color_set[3] = "#050505"; # silk
	} else {
		$color_set[0] = $color_set_grn[0];
		$color_set[2] = $color_set_grn[1];
	}
	#$color_set[1] = "#4A4135"; # stop mask
	#$color_set[3] = "#FFFFFF"; # silk
	if ($col_type =~ /gold/) {
		$color_set[4] = $color_gold;
	} else {
		$color_set[4] = $color_silver;
	}
	#$color_set[5] = "#FF007F"; # error

	print "/* XPM */\n";
	print "static char \*__[] = {\n";
	#print "/* columns rows colors chars-per-pixel */\n";

	printf("\"%d %d 7 1\",\n", $xsize_pix, $ysize_pix);
	for ($i = 0; $i <= 6; $i++ ) {
		printf("\"%s\tc %s\",\n",$color_char[$i], $color_set[$i]);
	}
	#print "\" \tc #0C1F89\",\n"; # backgrund 
	#print "\".\tc #4A4135\",\n"; # stc/sts
	#print "\"X\tc #1423DC\",\n"; # cmp/sol
	#print "\"#\tc #FFFFFF\",\n"; # plc/pls
	#print "\"+\tc #AC9528\",\n"; # pac/pas
	#print "\"Z\tc #FF007F\",\n"; # error
	#print "/* pixels */\n";

	# intialize canvus
	$current_layer = 0;
	for ($i = 0; $i < $ysize_pix ; $i++) {
		for ($j = 0; $j < $xsize_pix; $j++) {
			$canvus[$i][$j] = $current_layer;
		}
	}
}

# print canvus
sub draw_out {
	my($i,$j,$do_flip);
	$do_flip = @_[0];

	if ($do_flip) {
	    for ($i = $ysize_pix - 1; $i >= 0 ; $i--) {
		print "\"";
		for ($j = $xsize_pix -1; $j >= 0 ; $j--) {
			$v = $canvus[$i][$j];
			if ($v < 0 || $v > 6) {
				$v = 6;
			}
			printf("%s",$color_char[$v]);
		}
		if ($i != 0 ) {
			print "\",\n";
		}
	    }
	    print "};\n";
	} else {
	    for ($i = $ysize_pix - 1; $i >= 0 ; $i--) {
		print "\"";
		for ($j = 0; $j < $xsize_pix; $j++) {
			$v = $canvus[$i][$j];
			if ($v < 0 || $v > 6) {
				$v = 6;
			}
			printf("%s",$color_char[$v]);
		}
		if ($i != 0 ) {
			print "\",\n";
		}
	    }
	    print "};\n";
	}
}

sub draw_pixel {
	my($x,$y);
	$x = conv_coord(@_[0]);
	$y = conv_coord(@_[1]);

	if (($y < 0) || ($x < 0)) {
		return;
	}
	if ($canvus[$y][$x] < $current_layer) {
		$canvus[$y][$x] = $current_layer;
	}
}

sub draw_hline {
	my($xs,$xe,$y,$x,$t);
	$xs = conv_coord(@_[0]);
	$xe = conv_coord(@_[1]);
	$y = conv_coord(@_[2]);
	if ( $xe  < $xs ) {
		$t = $xs;
		$xs = $xe;
		$xe = $t;
	}
	if (($y < 0) || ($xe < 0)) {
		return;
	}
	if ($xs < 0) {
		$xs = 0;
	}
	for ($x = $xs; $x <= $xe; $x++) {
		if ($canvus[$y][$x] < $current_layer) {
			$canvus[$y][$x] = $current_layer;
		}
	}
}

sub draw_vline {
	my($ys,$ye,$y,$x,$t);
	$x = conv_coord(@_[0]);
	$ys = conv_coord(@_[1]);
	$ye = conv_coord(@_[2]);
	if ( $ys > $ye ) {
		$t = $ys;
		$ys = $ye;
		$ye = $t;
	}
	if (($x < 0) || ($ye < 0)) {
		return;
	}
	if ($ys < 0) {
		$ys = 0;
	}
	for ($y = $ys; $y <= $ye; $y++) {
		if ($canvus[$y][$x] < $current_layer) {
			$canvus[$y][$x] = $current_layer;
		}
	}
}

sub draw_rect {
	my($xs,$ys,$xe,$ye);
	$xs = @_[0];
	$ys = @_[1];
	$xe = @_[2];
	$ye = @_[3];
	draw_hline($xs, $xe, $ys);
	draw_hline($xs, $xe, $ye);
	draw_vline($xs, $ys, $ye);
	draw_vline($xe, $ys, $ye);
}

sub fill_rect {
	my($xs,$ys,$xe,$ye,$i,$j,$t);
	$xs = conv_coord(@_[0]);
	$xe = conv_coord(@_[2]);
	$ys = conv_coord(@_[1]);
	$ye = conv_coord(@_[3]);
	if ( $xe < $xs ) {
		$t = $xs;
		$xs = $xe;
		$xe = $t;
	}
	if ( $ye < $ys ) {
		$t = $ys;
		$ys = $ye;
		$ye = $t;
	}
	if (($xe < 0) || ($ye < 0)) {
		return;
	}
	if ($xs < 0) {
		$xs = 0;
	}
	if ($ys < 0) {
		$ys = 0;
	}
	for ($i = $ys; $i <= $ye; $i++) {
		for ($j = $xs; $j <= $xe; $j++) {
			if ($canvus[$i][$j] < $current_layer) {
				$canvus[$i][$j] = $current_layer;
			}
		}
	}
}

sub fill_octagon {
	my($xs,$ys,$xe,$ye,$i,$j,$d,$d2,$t);
	$xs = conv_coord(@_[0]);
	$xe = conv_coord(@_[2]);
	$ys = conv_coord(@_[1]);
	$ye = conv_coord(@_[3]);
	$d = (@_[2] - @_[0] + 1);
	if ( $xe < $xs ) {
		$t = $xs;
		$xs = $xe;
		$xe = $t;
		$d = (@_[0] - @_[2] + 1);
	}
	$d2 = (@_[3] - @_[1] + 1);
	if ( $ye < $ys ) {
		$t = $ys;
		$ys = $ye;
		$ye = $t;
		$d2 = (@_[1] - @_[3] + 1);
	}
	if (($xe < 0) || ($ye < 0)) {
		return;
	}
	if ($xs < 0) {
		$xs = 0;
	}
	if ($ys < 0) {
		$ys = 0;
	}
	if ($d2 < $d) {
		$d = $d2;
	}
	$d = conv_coord($d * 0.29289321);  # 1 / ( 2 + sqrt(2))
	for ($i = $ys+$d; $i <= $ye-$d; $i++) {
		for ($j = $xs; $j <= $xe; $j++) {
			if ($canvus[$i][$j] < $current_layer) {
				$canvus[$i][$j] = $current_layer;
			}
		}
	}
	for ($i = 0; $i < $d; $i++) {
		for ($j = $xs+$d-$i; $j <= $xe-$d+$i; $j++) {
			if ($canvus[$ys+$i][$j] < $current_layer) {
				$canvus[$ys+$i][$j] = $current_layer;
			}
			if ($canvus[$ye-$i][$j] < $current_layer) {
				$canvus[$ye-$i][$j] = $current_layer;
			}
		}
	}
}

# not used
sub draw_circle {
	my($x,$y,$r,$cx,$cy,$d,$s);
	$x = @_[0];
	$y = @_[1];
	$r = @_[2];

	$s = 5000.0 / $dpi;

	$d = 3 * $s - 2 * $r;
	$cy = $r;

	if ($r < $s) {
		draw_pixel($x , $y);
		return;
	}
	draw_pixel($x , $y + $cy);
	draw_pixel($x , $y - $cy);
	draw_pixel($x + $cy, $y);
	draw_pixel($x - $cy, $y);


	for ($cx = 0; $cx <= $cy; $cx += $s) {
		if ($d < 0) {
			$d += 6 * $s + 4 * $cx;
		} else {
			$d += 10 * $s + 4 * $cx - 4 * $cy;
			$cy = $cy - $s ;
		}
		draw_pixel($x + $cy, $y + $cx);
		draw_pixel($x - $cy, $y + $cx);
		draw_pixel($x + $cx, $y + $cy);
		draw_pixel($x - $cx, $y + $cy);
		draw_pixel($x + $cy, $y - $cx);
		draw_pixel($x - $cy, $y - $cx);
		draw_pixel($x + $cx, $y - $cy);
		draw_pixel($x - $cx, $y - $cy);
	}
}

sub fill_circle {
	my($x,$y,$r,$cx,$cy,$d);
	$x = @_[0];
	$y = @_[1];
	$r = @_[2];

	$s = 5000.0 / $dpi;
	$d = 3 * $s - 2 * $r;
	$cy = $r;

	if ($r < $s) {
		draw_pixel($x , $y);
		return;
	}
	draw_pixel($x , $y + $cy);
	draw_pixel($x , $y - $cy);
	draw_hline($x - $cy, $x + $cy, $y);

	for ($cx = 0; $cx <= $cy; $cx += $s) {
		if ($d < 0) {
			$d += 6 * $s + 4 * $cx;
		} else {
			$d += 10 * $s + 4 * $cx - 4 * $cy;
			$cy = $cy - $s ;
		}
		draw_hline($x - $cy, $x + $cy, $y + $cx);
		draw_hline($x - $cx, $x + $cx, $y + $cy);
		draw_hline($x - $cy, $x + $cy , $y - $cx);
		draw_hline($x - $cx, $x + $cx, $y - $cy);
	}
}

sub draw_line_thick_h {
	my($xs,$ys,$xe,$ye,$w,$i,$j,$d,$s);
	$s = 5000.0 / $dpi;
	if ( @_[3] > @_[1] ) {
		$xs = @_[0];
		$ys = @_[1];
		$xe = @_[2];
		$ye = @_[3];
	} else {
		$xs = @_[2];
		$ys = @_[3];
		$xe = @_[0];
		$ye = @_[1];
	}
	$w  = @_[4];

	$j = $xe - $xs + 1;
	$i = $ye - $ys + 1;
	$d = $s * $j / $i;
	$xs -= int($w/2);
	$j = $xs;
	while ($ys <= $ye) {
		draw_hline($xs ,$xs + $w - 1,$ys);
		$j += $d;
		$xs = int($j);
		$ys += $s;
	}
}

sub draw_line_thick_v {
	my($xs,$ys,$xe,$ye,$i,$j,$h,$d,$s);
	$s = 5000.0 / $dpi;
	if ( @_[2] > @_[0] ) {
		$xs = @_[0];
		$ys = @_[1];
		$xe = @_[2];
		$ye = @_[3];
	} else {
		$xs = @_[2];
		$ys = @_[3];
		$xe = @_[0];
		$ye = @_[1];
	}
	$h  = @_[4];

	$j = $xe - $xs + 1;
	$i = $ye - $ys + 1;
	$d = $s * $i / $j;
	$ys -= int($h/2);
	$i = $ys;
	while ($xs <= $xe) {
		draw_vline($xs ,$ys, $ys + $h -1);
		$i += $d;
		$ys = int($i);
		$xs += $s;
	}
}

sub draw_line_thick_h2 {
	my($xs,$ys,$xe,$ye,$w,$i,$j,$d);
	$s = 5000.0 / $dpi;
	if ( @_[3] > @_[1] ) {
		$xs = @_[0];
		$ys = @_[1];
		$xe = @_[2];
		$ye = @_[3];
	} else {
		$ys = @_[3];
		$xs = @_[2];
		$ye = @_[1];
		$xe = @_[0];
	}
	$w  = @_[4];

	$j = $xe - $xs + 1;
	$i = $ye - $ys + 1;
	$d = $s * $j / $i;
	$j = $xs;
	while ($ys <= $ye) {
		draw_hline($xs ,$xs + $w,$ys);
		$j += $d;
		$xs = int($j);
		$ys += $s;
	}
}

sub draw_line_thick_v2 {
	my($xs,$ys,$xe,$ye,$i,$j,$h,$d,$s);
	$s = 5000.0 / $dpi;
	if ( @_[2] > @_[0] ) {
		$xs = @_[0];
		$ys = @_[1];
		$xe = @_[2];
		$ye = @_[3];
	} else {
		$xs = @_[2];
		$ys = @_[3];
		$xe = @_[0];
		$ye = @_[1];
	}
	$h  = @_[4];

	$j = $xe - $xs + 1;
	$i = $ye - $ys + 1;
	$d = $s * $i / $j;
	$i = $ys;
	while ($xs <= $xe) {
		draw_vline($xs ,$ys, $ys + $h);
		$i += $d;
		$ys = int($i);
		$xs += $s;
	}
}

sub set_aperture {
	my($a);
	$a = @_[0];
	if ($a =~ /^R,([0-9\.]+)X([0-9\.]+)\*\%$/) {
		$cur_type = 1; # rectangle
		$cur_width = $1 * 10000.0;
		$cur_height = $2 * 10000.0;
	} elsif ($a =~ /^C,([0-9\.]+)\*\%$/) {
		$cur_type = 0; # circle
		$cur_diameter = $1 * 10000.0;
	} elsif ($a =~ /^OC8,([0-9\.]+)\*\%$/) {
		$cur_type = 2; # octagon
		$cur_width = $1 * 10000.0;
		$cur_height = $1 * 10000.0;
	}  else { # error
		$cur_type = -1; # error
	}
}

sub plot_aperture {
	my($xs,$xs,$xe,$ye,$x,$y,$d,$dx,$dy,$h,$w,$dd);
	$x = @_[0];
	$y = @_[1];
	$d = @_[2];
	$xs = $cur_x;
	$ys = $cur_y;
	$cur_x = $x;
	$cur_y = $y;
	if ($cur_y > $ys) {
		$xe = $cur_x;
		$ye = $cur_y;
	} else {
		$xe = $xs;
		$ye = $ys;
		$xs = $cur_x;
		$ys = $cur_y;
	}
	$w = $cur_width;
	$h = $cur_height;
	if ($cur_type == 1) { # rectangle
		$x = $cur_x - ($cur_width / 2);
		$y = $cur_y - ($cur_height / 2);
		fill_rect($x,$y, $x + $w -1, $y + $h -1);
	} elsif ($cur_type == 2) { # octagon
		$x = $cur_x - ($cur_width / 2);
		$y = $cur_y - ($cur_height / 2);
		fill_octagon($x,$y, $x + $w -1, $y + $h -1);
	} elsif ($cur_type == 0) {  # circle
		fill_circle($cur_x,$cur_y, ($cur_diameter/2));
	} else { # error
		my($save_layer);
		$save_layer = $current_layer;
		$current_layer = 255;
		fill_circle($cur_x,$cur_y, 400);
		$current_layer = $save_layer;
	}
	if ($d != 1) { # set start
		return;
	}
	if (($xs == $xe) && ($ys == $ye)) {
		return;
	}
	$dy = $ye - $ys;
	$dx = $xe - $xs;
	if ($dx > 0) {
		$dd = $xe - $xs;
	} else {
		$dd = $xs - $xe;
	}
	if ($cur_type != 0) { # rectangle / octagon
		if ($dy > $dd) {
			$d = ($cur_height/2);
			draw_line_thick_h($xs,$ys-$d,$xe,$ye-$d, $w);
			draw_line_thick_h($xs,$ys+$d,$xe,$ye+$d, $w);
		} else {
			$d = ($cur_width/2);
			draw_line_thick_v($xs-$d,$ys,$xe-$d,$ye,$h);
			draw_line_thick_v($xs+$d,$ys,$xe+$d,$ye,$h);
		}
	} else { # circle
		if ($dy > $dd) {
			$d = $dx/$dy;
			$dd = sqrt(1 + $d * $d);
			$dx =  (1/ $dd * $cur_diameter /2);
			$dy =  ($d/$dd * $cur_diameter /2);
			$dd =  ($dd * $cur_diameter /2);
			draw_line_thick_h2($xs - $dx,$ys + $dy,$xe - $dx,$ye + $dy,  $dd);
			draw_line_thick_h2($xs + $dx - $dd,$ys - $dy,$xe + $dx - $dd,$ye - $dy,  $dd);
		} else {
			$d = $dy/$dx;
			$dd = sqrt(1 + $d * $d) ;
			$dy =  (1/ $dd * $cur_diameter /2);
			$dx =  ($d/$dd * $cur_diameter /2);
			$dd =  ($dd * $cur_diameter /2);
			draw_line_thick_v2($xs + $dx,$ys - $dy,$xe + $dx,$ye - $dy,  $dd);
			draw_line_thick_v2($xs - $dx,$ys + $dy - $dd,$xe - $dx,$ye + $dy - $dd,  $dd);
		}
	}
}

